package com.minres.rdl.ui.preferences;

import com.minres.rdl.preferences.PreferenceConstants;
import org.eclipse.core.runtime.preferences.InstanceScope;
import org.eclipse.jface.preference.BooleanFieldEditor;
import org.eclipse.jface.preference.ComboFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.StringFieldEditor;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.eclipse.ui.preferences.ScopedPreferenceStore;

@SuppressWarnings("all")
public class RdlPreferencePage extends FieldEditorPreferencePage implements IWorkbenchPreferencePage {
  public RdlPreferencePage() {
    super(FieldEditorPreferencePage.GRID);
    final ScopedPreferenceStore store = new ScopedPreferenceStore(InstanceScope.INSTANCE, PreferenceConstants.SCOPE_NAME);
    this.setPreferenceStore(store);
    this.setDescription("Code generator configuration options");
  }
  
  @Override
  public void createFieldEditors() {
    Composite _fieldEditorParent = this.getFieldEditorParent();
    BooleanFieldEditor _booleanFieldEditor = new BooleanFieldEditor(PreferenceConstants.P_GENERATE_CSV, "Generate CSV:", _fieldEditorParent);
    this.addField(_booleanFieldEditor);
    Composite _fieldEditorParent_1 = this.getFieldEditorParent();
    ComboFieldEditor _comboFieldEditor = new ComboFieldEditor(PreferenceConstants.P_ADDRESSUNIT, "Address unit size", new String[][] { new String[] { "Byte (8bit)", "byte" }, new String[] { "Word (16bit)", "word" }, new String[] { "DWord (32bit)", "dword" } }, _fieldEditorParent_1);
    this.addField(_comboFieldEditor);
    Composite _fieldEditorParent_2 = this.getFieldEditorParent();
    StringFieldEditor _stringFieldEditor = new StringFieldEditor(PreferenceConstants.P_NAMESPACE, "Namespace of generated SystemC", 30, _fieldEditorParent_2);
    this.addField(_stringFieldEditor);
    Composite _fieldEditorParent_3 = this.getFieldEditorParent();
    BooleanFieldEditor _booleanFieldEditor_1 = new BooleanFieldEditor(PreferenceConstants.P_OVERWRITE_STUBS, "Always overwrite component stubs", _fieldEditorParent_3);
    this.addField(_booleanFieldEditor_1);
    Composite _fieldEditorParent_4 = this.getFieldEditorParent();
    ComboFieldEditor _comboFieldEditor_1 = new ComboFieldEditor(PreferenceConstants.P_FILETYPES_TO_GENERATE, "File types to generate", new String[][] { new String[] { "All", "all" }, new String[] { "FW only", "fw" }, new String[] { "SC components", "sc-comp" } }, _fieldEditorParent_4);
    this.addField(_comboFieldEditor_1);
    Composite _fieldEditorParent_5 = this.getFieldEditorParent();
    StringFieldEditor _stringFieldEditor_1 = new StringFieldEditor(PreferenceConstants.P_COMPONENT_PATH, "relative path for SystemC files", 30, _fieldEditorParent_5);
    this.addField(_stringFieldEditor_1);
    Composite _fieldEditorParent_6 = this.getFieldEditorParent();
    StringFieldEditor _stringFieldEditor_2 = new StringFieldEditor(PreferenceConstants.P_FIRMWARE_PATH, "relative path for FW files", 30, _fieldEditorParent_6);
    this.addField(_stringFieldEditor_2);
    Composite _fieldEditorParent_7 = this.getFieldEditorParent();
    StringFieldEditor _stringFieldEditor_3 = new StringFieldEditor(PreferenceConstants.P_COPYRIGHT_HEADER, "Copyright header", 40, 5, StringFieldEditor.VALIDATE_ON_KEY_STROKE, _fieldEditorParent_7);
    this.addField(_stringFieldEditor_3);
  }
  
  @Override
  public void init(final IWorkbench workbench) {
  }
}
